/**
 * An enum for defining streaming endpoints that can be subscribed to.
 */
// eslint-disable-next-line no-unused-vars
class StreamingEndpoint {
  static Capture = new StreamingEndpoint('capture/status');

  static Layers = new StreamingEndpoint('status/layers');

  static Props = new StreamingEndpoint('props');

  static StageMessage = new StreamingEndpoint('stage/message');

  static Timers = new StreamingEndpoint('timers/current');

  static TransportAnnouncement = new StreamingEndpoint('transport/announcement/current');

  static TransportAudio = new StreamingEndpoint('transport/audio/current');

  static TransportPresentation = new StreamingEndpoint('transport/presentation/current');

  static Timeline = new StreamingEndpoint('presentation/focused/timeline');

  constructor(path) {
    this.path = path;
  }
}

if (typeof module !== 'undefined') {
  module.exports = StreamingEndpoint;
}
