/* global ActionBase */

class LookAction extends ActionBase {
  constructor(apiManager) {
    super(apiManager);
    this.shouldPollForData = true;
  }

  async pollForData(context, action) {
    try {
      const looks = await this.apiManager.getLooks();
      ActionBase.sendToPropertyInspector(context, { availableLooks: looks }, action);
    } catch (error) {
      console.warn(error);
      ActionBase.sendToPropertyInspector(context, { availableLooks: null }, action);
    }

    super.pollForData(context, action);
  }

  async performAction(settings) {
    const lookId = settings.lookSelector;
    if (typeof lookId === 'undefined') {
      throw new Error('lookSelector not defined in settings');
    }
    await this.apiManager.triggerLook(lookId);
  }
}

if (typeof module !== 'undefined') {
  module.exports = LookAction;
}
