/* global ActionBase */

class SlideAction extends ActionBase {
  setDefaultsInSettings(settings) {
    let didUpdateSettings = false;

    if (typeof settings.modeSelector === 'undefined') {
      settings.modeSelector = 'TriggerNextSlide';
      didUpdateSettings = true;
    }

    if (typeof settings['icon-state'] === 'undefined') {
      settings['icon-state'] = 'next';
      didUpdateSettings = true;
    }

    return super.setDefaultsInSettings(settings) || didUpdateSettings;
  }

  async performAction(settings) {
    const modeSelection = settings.modeSelector;
    if (typeof modeSelection === 'undefined') {
      throw new Error('modeSelector not defined in settings');
    }

    switch (modeSelection) {
      case ('TriggerNextSlide'):
        await this.apiManager.triggerNextSlide();
        break;
      case ('TriggerPreviousSlide'):
        await this.apiManager.triggerPreviousSlide();
        break;
      default:
        throw new Error(`Unhandled action selection: ${modeSelection}`);
    }
  }
}

if (typeof module !== 'undefined') {
  module.exports = SlideAction;
}
