/* global AudioAction, CaptureAction, ClearAction, FindMyMouseAction, GroupAction, LookAction, MacroAction,
PropAction, SlideAction, StageAction, TimelineAction, TimerAction, TransportAction, VideoInputAction */
/* global AUDIO_ACTION_ID, CAPTURE_ACTION_ID, CLEAR_ACTION_ID, FIND_MY_MOUSE_ACTION_ID, GROUP_ACTION_ID, LOOK_ACTION_ID, MACRO_ACTION_ID,
PROP_ACTION_ID, SLIDE_ACTION_ID, STAGE_ACTION_ID, TIMELINE_ACTION_ID, TIMER_ACTION_ID, TRANSPORT_ACTION_ID, VIDEO_INPUT_ACTION_ID */
/* global WILL_APPEAR, WILL_DISAPPEAR, KEY_UP, DID_RECEIVE_SETTINGS, KEY_DOWN, SEND_TO_PLUGIN,
PROPERTY_INSPECTOR_DID_APPEAR, PROPERTY_INSPECTOR_DID_DISAPPEAR */
/* global $SD, APIManager */

/* eslint-disable max-len */

const apiManager = new APIManager(''); // Setting base URL to empty string to start. User will need to configure via UI.

function connected() {
  const audioAction = new AudioAction(apiManager);
  $SD.on(AUDIO_ACTION_ID + WILL_APPEAR, (json) => audioAction.onWillAppear(json));
  $SD.on(AUDIO_ACTION_ID + WILL_DISAPPEAR, (json) => audioAction.onWillDisappear(json));
  $SD.on(AUDIO_ACTION_ID + KEY_UP, (json) => audioAction.onKeyUp(json));
  $SD.on(AUDIO_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => audioAction.onDidReceiveSettings(json));
  $SD.on(AUDIO_ACTION_ID + KEY_DOWN, (json) => audioAction.onKeyDown(json));
  $SD.on(AUDIO_ACTION_ID + SEND_TO_PLUGIN, (json) => audioAction.onSendToPlugin(json));
  $SD.on(AUDIO_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => audioAction.onPropertyInspectorDidAppear(json));
  $SD.on(AUDIO_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => audioAction.onPropertyInspectorDidDisappear(json));

  const captureAction = new CaptureAction(apiManager);
  $SD.on(CAPTURE_ACTION_ID + WILL_APPEAR, (json) => captureAction.onWillAppear(json));
  $SD.on(CAPTURE_ACTION_ID + WILL_DISAPPEAR, (json) => captureAction.onWillDisappear(json));
  $SD.on(CAPTURE_ACTION_ID + KEY_UP, (json) => captureAction.onKeyUp(json));
  $SD.on(CAPTURE_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => captureAction.onDidReceiveSettings(json));
  $SD.on(CAPTURE_ACTION_ID + KEY_DOWN, (json) => captureAction.onKeyDown(json));
  $SD.on(CAPTURE_ACTION_ID + SEND_TO_PLUGIN, (json) => captureAction.onSendToPlugin(json));
  $SD.on(CAPTURE_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => captureAction.onPropertyInspectorDidAppear(json));
  $SD.on(CAPTURE_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => captureAction.onPropertyInspectorDidDisappear(json));

  const clearAction = new ClearAction(apiManager);
  $SD.on(CLEAR_ACTION_ID + WILL_APPEAR, (json) => clearAction.onWillAppear(json));
  $SD.on(CLEAR_ACTION_ID + WILL_DISAPPEAR, (json) => clearAction.onWillDisappear(json));
  $SD.on(CLEAR_ACTION_ID + KEY_UP, (json) => clearAction.onKeyUp(json));
  $SD.on(CLEAR_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => clearAction.onDidReceiveSettings(json));
  $SD.on(CLEAR_ACTION_ID + KEY_DOWN, (json) => clearAction.onKeyDown(json));
  $SD.on(CLEAR_ACTION_ID + SEND_TO_PLUGIN, (json) => clearAction.onSendToPlugin(json));
  $SD.on(CLEAR_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => clearAction.onPropertyInspectorDidAppear(json));
  $SD.on(CLEAR_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => clearAction.onPropertyInspectorDidDisappear(json));

  const findMyMouseAction = new FindMyMouseAction(apiManager);
  $SD.on(FIND_MY_MOUSE_ACTION_ID + WILL_APPEAR, (json) => findMyMouseAction.onWillAppear(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + WILL_DISAPPEAR, (json) => findMyMouseAction.onWillDisappear(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + KEY_UP, (json) => findMyMouseAction.onKeyUp(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + KEY_DOWN, (json) => findMyMouseAction.onKeyDown(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + SEND_TO_PLUGIN, (json) => findMyMouseAction.onSendToPlugin(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => findMyMouseAction.onDidReceiveSettings(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => findMyMouseAction.onPropertyInspectorDidAppear(json));
  $SD.on(FIND_MY_MOUSE_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => findMyMouseAction.onPropertyInspectorDidDisappear(json));

  const groupAction = new GroupAction(apiManager);
  $SD.on(GROUP_ACTION_ID + WILL_APPEAR, (json) => groupAction.onWillAppear(json));
  $SD.on(GROUP_ACTION_ID + WILL_DISAPPEAR, (json) => groupAction.onWillDisappear(json));
  $SD.on(GROUP_ACTION_ID + KEY_UP, (json) => groupAction.onKeyUp(json));
  $SD.on(GROUP_ACTION_ID + KEY_DOWN, (json) => groupAction.onKeyDown(json));
  $SD.on(GROUP_ACTION_ID + SEND_TO_PLUGIN, (json) => groupAction.onSendToPlugin(json));
  $SD.on(GROUP_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => groupAction.onDidReceiveSettings(json));
  $SD.on(GROUP_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => groupAction.onPropertyInspectorDidAppear(json));
  $SD.on(GROUP_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => groupAction.onPropertyInspectorDidDisappear(json));

  const lookAction = new LookAction(apiManager);
  $SD.on(LOOK_ACTION_ID + WILL_APPEAR, (json) => lookAction.onWillAppear(json));
  $SD.on(LOOK_ACTION_ID + WILL_DISAPPEAR, (json) => lookAction.onWillDisappear(json));
  $SD.on(LOOK_ACTION_ID + KEY_UP, (json) => lookAction.onKeyUp(json));
  $SD.on(LOOK_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => lookAction.onDidReceiveSettings(json));
  $SD.on(LOOK_ACTION_ID + KEY_DOWN, (json) => lookAction.onKeyDown(json));
  $SD.on(LOOK_ACTION_ID + SEND_TO_PLUGIN, (json) => lookAction.onSendToPlugin(json));
  $SD.on(LOOK_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => lookAction.onPropertyInspectorDidAppear(json));
  $SD.on(LOOK_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => lookAction.onPropertyInspectorDidDisappear(json));

  const macroAction = new MacroAction(apiManager);
  $SD.on(MACRO_ACTION_ID + WILL_APPEAR, (json) => macroAction.onWillAppear(json));
  $SD.on(MACRO_ACTION_ID + WILL_DISAPPEAR, (json) => macroAction.onWillDisappear(json));
  $SD.on(MACRO_ACTION_ID + KEY_UP, (json) => macroAction.onKeyUp(json));
  $SD.on(MACRO_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => macroAction.onDidReceiveSettings(json));
  $SD.on(MACRO_ACTION_ID + KEY_DOWN, (json) => macroAction.onKeyDown(json));
  $SD.on(MACRO_ACTION_ID + SEND_TO_PLUGIN, (json) => macroAction.onSendToPlugin(json));
  $SD.on(MACRO_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => macroAction.onPropertyInspectorDidAppear(json));
  $SD.on(MACRO_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => macroAction.onPropertyInspectorDidDisappear(json));

  const propAction = new PropAction(apiManager);
  $SD.on(PROP_ACTION_ID + WILL_APPEAR, (json) => propAction.onWillAppear(json));
  $SD.on(PROP_ACTION_ID + WILL_DISAPPEAR, (json) => propAction.onWillDisappear(json));
  $SD.on(PROP_ACTION_ID + KEY_UP, (json) => propAction.onKeyUp(json));
  $SD.on(PROP_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => propAction.onDidReceiveSettings(json));
  $SD.on(PROP_ACTION_ID + KEY_DOWN, (json) => propAction.onKeyDown(json));
  $SD.on(PROP_ACTION_ID + SEND_TO_PLUGIN, (json) => propAction.onSendToPlugin(json));
  $SD.on(PROP_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => propAction.onPropertyInspectorDidAppear(json));
  $SD.on(PROP_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => propAction.onPropertyInspectorDidDisappear(json));

  const slideAction = new SlideAction(apiManager);
  $SD.on(SLIDE_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => slideAction.onDidReceiveSettings(json));
  $SD.on(SLIDE_ACTION_ID + WILL_APPEAR, (json) => slideAction.onWillAppear(json));
  $SD.on(SLIDE_ACTION_ID + WILL_DISAPPEAR, (json) => slideAction.onWillDisappear(json));
  $SD.on(SLIDE_ACTION_ID + KEY_UP, (json) => slideAction.onKeyUp(json));
  $SD.on(SLIDE_ACTION_ID + KEY_DOWN, (json) => slideAction.onKeyDown(json));
  $SD.on(SLIDE_ACTION_ID + SEND_TO_PLUGIN, (json) => slideAction.onSendToPlugin(json));
  $SD.on(SLIDE_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => slideAction.onPropertyInspectorDidAppear(json));
  $SD.on(SLIDE_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => slideAction.onPropertyInspectorDidDisappear(json));

  const stageAction = new StageAction(apiManager);
  $SD.on(STAGE_ACTION_ID + WILL_APPEAR, (json) => stageAction.onWillAppear(json));
  $SD.on(STAGE_ACTION_ID + WILL_DISAPPEAR, (json) => stageAction.onWillDisappear(json));
  $SD.on(STAGE_ACTION_ID + KEY_UP, (json) => stageAction.onKeyUp(json));
  $SD.on(STAGE_ACTION_ID + KEY_DOWN, (json) => stageAction.onKeyDown(json));
  $SD.on(STAGE_ACTION_ID + SEND_TO_PLUGIN, (json) => stageAction.onSendToPlugin(json));
  $SD.on(STAGE_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => stageAction.onDidReceiveSettings(json));
  $SD.on(STAGE_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => stageAction.onPropertyInspectorDidAppear(json));
  $SD.on(STAGE_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => stageAction.onPropertyInspectorDidDisappear(json));

  const timelineAction = new TimelineAction(apiManager);
  $SD.on(TIMELINE_ACTION_ID + WILL_APPEAR, (json) => timelineAction.onWillAppear(json));
  $SD.on(TIMELINE_ACTION_ID + WILL_DISAPPEAR, (json) => timelineAction.onWillDisappear(json));
  $SD.on(TIMELINE_ACTION_ID + KEY_UP, (json) => timelineAction.onKeyUp(json));
  $SD.on(TIMELINE_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => timelineAction.onDidReceiveSettings(json));
  $SD.on(TIMELINE_ACTION_ID + KEY_DOWN, (json) => timelineAction.onKeyDown(json));
  $SD.on(TIMELINE_ACTION_ID + SEND_TO_PLUGIN, (json) => timelineAction.onSendToPlugin(json));
  $SD.on(TIMELINE_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => timelineAction.onPropertyInspectorDidAppear(json));
  $SD.on(TIMELINE_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => timelineAction.onPropertyInspectorDidDisappear(json));

  const timerAction = new TimerAction(apiManager);
  $SD.on(TIMER_ACTION_ID + WILL_APPEAR, (json) => timerAction.onWillAppear(json));
  $SD.on(TIMER_ACTION_ID + WILL_DISAPPEAR, (json) => timerAction.onWillDisappear(json));
  $SD.on(TIMER_ACTION_ID + KEY_UP, (json) => timerAction.onKeyUp(json));
  $SD.on(TIMER_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => timerAction.onDidReceiveSettings(json));
  $SD.on(TIMER_ACTION_ID + KEY_DOWN, (json) => timerAction.onKeyDown(json));
  $SD.on(TIMER_ACTION_ID + SEND_TO_PLUGIN, (json) => timerAction.onSendToPlugin(json));
  $SD.on(TIMER_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => timerAction.onPropertyInspectorDidAppear(json));
  $SD.on(TIMER_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => timerAction.onPropertyInspectorDidDisappear(json));

  const transportAction = new TransportAction(apiManager);
  $SD.on(TRANSPORT_ACTION_ID + WILL_APPEAR, (json) => transportAction.onWillAppear(json));
  $SD.on(TRANSPORT_ACTION_ID + WILL_DISAPPEAR, (json) => transportAction.onWillDisappear(json));
  $SD.on(TRANSPORT_ACTION_ID + KEY_UP, (json) => transportAction.onKeyUp(json));
  $SD.on(TRANSPORT_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => transportAction.onDidReceiveSettings(json));
  $SD.on(TRANSPORT_ACTION_ID + KEY_DOWN, (json) => transportAction.onKeyDown(json));
  $SD.on(TRANSPORT_ACTION_ID + SEND_TO_PLUGIN, (json) => transportAction.onSendToPlugin(json));
  $SD.on(TRANSPORT_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => transportAction.onPropertyInspectorDidAppear(json));
  $SD.on(TRANSPORT_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => transportAction.onPropertyInspectorDidDisappear(json));

  const videoInputAction = new VideoInputAction(apiManager);
  $SD.on(VIDEO_INPUT_ACTION_ID + WILL_APPEAR, (json) => videoInputAction.onWillAppear(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + WILL_DISAPPEAR, (json) => videoInputAction.onWillDisappear(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + KEY_UP, (json) => videoInputAction.onKeyUp(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + DID_RECEIVE_SETTINGS, (json) => videoInputAction.onDidReceiveSettings(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + KEY_DOWN, (json) => videoInputAction.onKeyDown(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + SEND_TO_PLUGIN, (json) => videoInputAction.onSendToPlugin(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + PROPERTY_INSPECTOR_DID_APPEAR, (json) => videoInputAction.onPropertyInspectorDidAppear(json));
  $SD.on(VIDEO_INPUT_ACTION_ID + PROPERTY_INSPECTOR_DID_DISAPPEAR, (json) => videoInputAction.onPropertyInspectorDidDisappear(json));
}

$SD.on('connected', () => connected());

$SD.on('didReceiveGlobalSettings', (json) => {
  const connection = json.payload.settings.selectedConnection;
  if (connection) {
    apiManager.baseUrl = `http://${connection.socketAddress}`;
  } else {
    apiManager.baseUrl = '';
  }
});
