/* eslint-disable no-unused-vars */

// Action IDs
const AUDIO_ACTION_ID = 'com.renewedvision.propresenter.audio';
const CAPTURE_ACTION_ID = 'com.renewedvision.propresenter.capture';
const CLEAR_ACTION_ID = 'com.renewedvision.propresenter.clear';
const FIND_MY_MOUSE_ACTION_ID = 'com.renewedvision.propresenter.findmymouse';
const GROUP_ACTION_ID = 'com.renewedvision.propresenter.group';
const LOOK_ACTION_ID = 'com.renewedvision.propresenter.look';
const MACRO_ACTION_ID = 'com.renewedvision.propresenter.macro';
const PROP_ACTION_ID = 'com.renewedvision.propresenter.prop';
const SLIDE_ACTION_ID = 'com.renewedvision.propresenter.slide';
const STAGE_ACTION_ID = 'com.renewedvision.propresenter.stagemessage';
const TIMELINE_ACTION_ID = 'com.renewedvision.propresenter.timeline';
const TIMER_ACTION_ID = 'com.renewedvision.propresenter.timer';
const TRANSPORT_ACTION_ID = 'com.renewedvision.propresenter.transport';
const VIDEO_INPUT_ACTION_ID = 'com.renewedvision.propresenter.videoinput';

// Events
const WILL_APPEAR = '.willAppear';
const WILL_DISAPPEAR = '.willDisappear';
const KEY_UP = '.keyUp';
const KEY_DOWN = '.keyDown';
const SEND_TO_PLUGIN = '.sendToPlugin';
const DID_RECEIVE_SETTINGS = '.didReceiveSettings';
const PROPERTY_INSPECTOR_DID_APPEAR = '.propertyInspectorDidAppear';
const PROPERTY_INSPECTOR_DID_DISAPPEAR = '.propertyInspectorDidDisappear';

// IPv4 regex pattern
const IPV4_REGEX_PATTERN = '^(?:25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]\\d|\\d)(?:\\.(?:25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]\\d|\\d)){3}$';

/** Light and Dark Key Icon Paths */

// Audio Action Key Icon Paths
const AUDIO_LIGHT_ICON_PATH = './images/key-icons/audio/audioTriggerKey_Light@2x.png';
const AUDIO_DARK_ICON_PATH = './images/key-icons/audio/audioTriggerKey_Dark@2x.png';

// Stage Action Key Icon Paths
const STAGE_LIGHT_ICON_PATH = './images/key-icons/stage/stageShowKey_Light@2x.png';
const STAGE_DARK_ICON_PATH = './images/key-icons/stage/stageShowKey_Dark@2x.png';

// Find My Mouse Action Key Icon Paths
const FIND_MY_MOUSE_LIGHT_ICON_PATH = './images/key-icons/findMyMouse/findMyMouseKey_Light@2x.png';
const FIND_MY_MOUSE_DARK_ICON_PATH = './images/key-icons/findMyMouse/findMyMouseKey_Dark@2x.png';

// Capture Action Key Icon Paths
const CAPTURE_START_LIGHT_ICON_PATH = './images/key-icons/capture/captureStartKey_Light@2x.png';
const CAPTURE_START_DARK_ICON_PATH = './images/key-icons/capture/captureStartKey_Dark@2x.png';
const CAPTURE_STOP_LIGHT_ICON_PATH = './images/key-icons/capture/captureStopKey_Light@2x.png';
const CAPTURE_STOP_DARK_ICON_PATH = './images/key-icons/capture/captureStopKey_Dark@2x.png';

// Clear Action Key Icon Paths

// Layers
// Audio Layer Icon
const CLEAR_AUDIO_LIGHT_ICON_PATH = './images/key-icons/clear/clearAudioKey_Light@2x.png';
const CLEAR_AUDIO_DARK_ICON_PATH = './images/key-icons/clear/clearAudioKey_Dark@2x.png';
// Messages Layer Icon
const CLEAR_MESSAGES_LIGHT_ICON_PATH = './images/key-icons/clear/clearMessagesKey_Light@2x.png';
const CLEAR_MESSAGES_DARK_ICON_PATH = './images/key-icons/clear/clearMessagesKey_Dark@2x.png';
// Props Layer Icon
const CLEAR_PROPS_LIGHT_ICON_PATH = './images/key-icons/clear/clearPropsKey_Light@2x.png';
const CLEAR_PROPS_DARK_ICON_PATH = './images/key-icons/clear/clearPropsKey_Dark@2x.png';
// Announcements Layer Icon
const CLEAR_ANNOUNCEMENTS_LIGHT_ICON_PATH = './images/key-icons/clear/clearAnnouncementsKey_Light@2x.png';
const CLEAR_ANNOUNCEMENTS_DARK_ICON_PATH = './images/key-icons/clear/clearAnnouncementsKey_Dark@2x.png';
// Presentation Layer Icon
const CLEAR_PRESENTATION_LIGHT_ICON_PATH = './images/key-icons/clear/clearPresentationKey_Light@2x.png';
const CLEAR_PRESENTATION_DARK_ICON_PATH = './images/key-icons/clear/clearPresentationKey_Dark@2x.png';
// Media Layer Icon
const CLEAR_MEDIA_LIGHT_ICON_PATH = './images/key-icons/clear/clearMediaKey_Light@2x.png';
const CLEAR_MEDIA_DARK_ICON_PATH = './images/key-icons/clear/clearMediaKey_Dark@2x.png';
// Video Input Layer Icon
const CLEAR_VIDEO_INPUT_LIGHT_ICON_PATH = './images/key-icons/clear/clearVideoInputKey_Light@2x.png';
const CLEAR_VIDEO_INPUT_DARK_ICON_PATH = './images/key-icons/clear/clearVideoInputKey_Dark@2x.png';

// Clear Groups
// Zero Icon
const CLEAR_GROUP_ZERO_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup0Key_Light@2x.png';
const CLEAR_GROUP_ZERO_DARK_ICON_PATH = './images/key-icons/clear/clearGroup0Key_Dark@2x.png';
// One Icon
const CLEAR_GROUP_ONE_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup1Key_Light@2x.png';
const CLEAR_GROUP_ONE_DARK_ICON_PATH = './images/key-icons/clear/clearGroup1Key_Dark@2x.png';
// Two Icon
const CLEAR_GROUP_TWO_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup2Key_Light@2x.png';
const CLEAR_GROUP_TWO_DARK_ICON_PATH = './images/key-icons/clear/clearGroup2Key_Dark@2x.png';
// Three Icon
const CLEAR_GROUP_THREE_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup3Key_Light@2x.png';
const CLEAR_GROUP_THREE_DARK_ICON_PATH = './images/key-icons/clear/clearGroup3Key_Dark@2x.png';
// Four Icon
const CLEAR_GROUP_FOUR_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup4Key_Light@2x.png';
const CLEAR_GROUP_FOUR_DARK_ICON_PATH = './images/key-icons/clear/clearGroup4Key_Dark@2x.png';
// Five Icon
const CLEAR_GROUP_FIVE_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup5Key_Light@2x.png';
const CLEAR_GROUP_FIVE_DARK_ICON_PATH = './images/key-icons/clear/clearGroup5Key_Dark@2x.png';
// Six Icon
const CLEAR_GROUP_SIX_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup6Key_Light@2x.png';
const CLEAR_GROUP_SIX_DARK_ICON_PATH = './images/key-icons/clear/clearGroup6Key_Dark@2x.png';
// Seven Icon
const CLEAR_GROUP_SEVEN_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup7Key_Light@2x.png';
const CLEAR_GROUP_SEVEN_DARK_ICON_PATH = './images/key-icons/clear/clearGroup7Key_Dark@2x.png';
// Eight Icon
const CLEAR_GROUP_EIGHT_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup8Key_Light@2x.png';
const CLEAR_GROUP_EIGHT_DARK_ICON_PATH = './images/key-icons/clear/clearGroup8Key_Dark@2x.png';
// Nine Icon
const CLEAR_GROUP_NINE_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroup9Key_Light@2x.png';
const CLEAR_GROUP_NINE_DARK_ICON_PATH = './images/key-icons/clear/clearGroup9Key_Dark@2x.png';
// All Icon
const CLEAR_GROUP_ALL_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupAllKey_Light@2x.png';
const CLEAR_GROUP_ALL_DARK_ICON_PATH = './images/key-icons/clear/clearGroupAllKey_Dark@2x.png';
// Announcements Icon
const CLEAR_GROUP_ANNOUNCEMENTS_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupAnnouncementsKey_Light@2x.png';
const CLEAR_GROUP_ANNOUNCEMENTS_DARK_ICON_PATH = './images/key-icons/clear/clearGroupAnnouncementsKey_Dark@2x.png';
// Arrow Icon
const CLEAR_GROUP_ARROW_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupArrowKey_Light@2x.png';
const CLEAR_GROUP_ARROW_DARK_ICON_PATH = './images/key-icons/clear/clearGroupArrowKey_Dark@2x.png';
// Bell Icon
const CLEAR_GROUP_BELL_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupBellKey_Light@2x.png';
const CLEAR_GROUP_BELL_DARK_ICON_PATH = './images/key-icons/clear/clearGroupBellKey_Dark@2x.png';
// Cloud Icon
const CLEAR_GROUP_CLOUD_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupCloudKey_Light@2x.png';
const CLEAR_GROUP_CLOUD_DARK_ICON_PATH = './images/key-icons/clear/clearGroupCloudKey_Dark@2x.png';
// Cupcake Icon
const CLEAR_GROUP_CUPCAKE_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupCupcakeKey_Light@2x.png';
const CLEAR_GROUP_CUPCAKE_DARK_ICON_PATH = './images/key-icons/clear/clearGroupCupcakeKey_Dark@2x.png';
// Exclamation Icon
const CLEAR_GROUP_EXCLAMATION_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupExclamationKey_Light@2x.png';
const CLEAR_GROUP_EXCLAMATION_DARK_ICON_PATH = './images/key-icons/clear/clearGroupExclamationKey_Dark@2x.png';
// Eyeglasses Icon
const CLEAR_GROUP_EYEGLASSES_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupEyeglassesKey_Light@2x.png';
const CLEAR_GROUP_EYEGLASSES_DARK_ICON_PATH = './images/key-icons/clear/clearGroupEyeglassesKey_Dark@2x.png';
// Flask Icon
const CLEAR_GROUP_FLASK_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupFlaskKey_Light@2x.png';
const CLEAR_GROUP_FLASK_DARK_ICON_PATH = './images/key-icons/clear/clearGroupFlaskKey_Dark@2x.png';
// Flower Icon
const CLEAR_GROUP_FLOWER_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupFlowerKey_Light@2x.png';
const CLEAR_GROUP_FLOWER_DARK_ICON_PATH = './images/key-icons/clear/clearGroupFlowerKey_Dark@2x.png';
// Hat Icon
const CLEAR_GROUP_HAT_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupHatKey_Light@2x.png';
const CLEAR_GROUP_HAT_DARK_ICON_PATH = './images/key-icons/clear/clearGroupHatKey_Dark@2x.png';
// Heart Icon
const CLEAR_GROUP_HEART_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupHeartKey_Light@2x.png';
const CLEAR_GROUP_HEART_DARK_ICON_PATH = './images/key-icons/clear/clearGroupHeartKey_Dark@2x.png';
// Light Bulb Icon
const CLEAR_GROUP_LIGHT_BULB_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupLightbulbKey_Light@2x.png';
const CLEAR_GROUP_LIGHT_BULB_DARK_ICON_PATH = './images/key-icons/clear/clearGroupLightbulbKey_Dark@2x.png';
// Message Icon
const CLEAR_GROUP_MESSAGE_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupMessageKey_Light@2x.png';
const CLEAR_GROUP_MESSAGE_DARK_ICON_PATH = './images/key-icons/clear/clearGroupMessageKey_Dark@2x.png';
// Music Icon
const CLEAR_GROUP_MUSIC_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupMusicKey_Light@2x.png';
const CLEAR_GROUP_MUSIC_DARK_ICON_PATH = './images/key-icons/clear/clearGroupMusicKey_Dark@2x.png';
// Paperclip Icon
const CLEAR_GROUP_PAPERCLIP_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupPaperclipKey_Light@2x.png';
const CLEAR_GROUP_PAPERCLIP_DARK_ICON_PATH = './images/key-icons/clear/clearGroupPaperclipKey_Dark@2x.png';
// Play Icon
const CLEAR_GROUP_PLAY_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupPlayKey_Light@2x.png';
const CLEAR_GROUP_PLAY_DARK_ICON_PATH = './images/key-icons/clear/clearGroupPlayKey_Dark@2x.png';
// Presentation Icon
const CLEAR_GROUP_PRESENTATION_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupPresentationKey_Light@2x.png';
const CLEAR_GROUP_PRESENTATION_DARK_ICON_PATH = './images/key-icons/clear/clearGroupPresentationKey_Dark@2x.png';
// Star Icon
const CLEAR_GROUP_STAR_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupStarKey_Light@2x.png';
const CLEAR_GROUP_STAR_DARK_ICON_PATH = './images/key-icons/clear/clearGroupStarKey_Dark@2x.png';
// Sunglasses Icon
const CLEAR_GROUP_SUNGLASSES_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupSunglassesKey_Light@2x.png';
const CLEAR_GROUP_SUNGLASSES_DARK_ICON_PATH = './images/key-icons/clear/clearGroupSunglassesKey_Dark@2x.png';
// Sun Icon
const CLEAR_GROUP_SUN_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupSunKey_Light@2x.png';
const CLEAR_GROUP_SUN_DARK_ICON_PATH = './images/key-icons/clear/clearGroupSunKey_Dark@2x.png';
// Target Icon
const CLEAR_GROUP_TARGET_LIGHT_ICON_PATH = './images/key-icons/clear/clearGroupTargetKey_Light@2x.png';
const CLEAR_GROUP_TARGET_DARK_ICON_PATH = './images/key-icons/clear/clearGroupTargetKey_Dark@2x.png';

// Group Action Key Icon Paths
const GROUP_LIGHT_ICON_PATH = './images/key-icons/group/groupKey_Light@2x.png';
const GROUP_DARK_ICON_PATH = './images/key-icons/group/groupKey_Dark@2x.png';

// Stage Action Key Icon Paths
const STAGE_SHOW_LIGHT_ICON_PATH = './images/key-icons/stage/stageShowKey_Light@2x.png';
const STAGE_SHOW_DARK_ICON_PATH = './images/key-icons/stage/stageShowKey_Dark@2x.png';
const STAGE_HIDE_LIGHT_ICON_PATH = './images/key-icons/stage/stageHideKey_Light@2x.png';
const STAGE_HIDE_DARK_ICON_PATH = './images/key-icons/stage/stageHideKey_Dark@2x.png';

// Slide Action Key Icon Paths
const SLIDE_NEXT_LIGHT_ICON_PATH = './images/key-icons/slide/slideNextKey_Light@2x.png';
const SLIDE_NEXT_DARK_ICON_PATH = './images/key-icons/slide/slideNextKey_Dark@2x.png';
const SLIDE_PREVIOUS_LIGHT_ICON_PATH = './images/key-icons/slide/slidePreviousKey_Light@2x.png';
const SLIDE_PREVIOUS_DARK_ICON_PATH = './images/key-icons/slide/slidePreviousKey_Dark@2x.png';

// Timeline and Timer
const PLAY_LIGHT_ICON_PATH = './images/key-icons/timelineAndTimer/playKey_Light@2x.png';
const PLAY_DARK_ICON_PATH = './images/key-icons/timelineAndTimer/playKey_Dark@2x.png';
const STOP_LIGHT_ICON_PATH = './images/key-icons/timelineAndTimer/stopKey_Light@2x.png';
const STOP_DARK_ICON_PATH = './images/key-icons/timelineAndTimer/stopKey_Dark@2x.png';
const RESET_LIGHT_ICON_PATH = './images/key-icons/timelineAndTimer/resetKey_Light@2x.png';
const RESET_DARK_ICON_PATH = './images/key-icons/timelineAndTimer/resetKey_Dark@2x.png';
const INCREMENT_LIGHT_ICON_PATH = './images/key-icons/timelineAndTimer/incrementKey_Light@2x.png';
const INCREMENT_DARK_ICON_PATH = './images/key-icons/timelineAndTimer/incrementKey_Dark@2x.png';

// Transport Action Key Icon Paths
const TRANSPORT_PLAY_LIGHT_ICON_PATH = './images/key-icons/transport/transportPlayKey_Light@2x.png';
const TRANSPORT_PLAY_DARK_ICON_PATH = './images/key-icons/transport/transportPlayKey_Dark@2x.png';
const TRANSPORT_PAUSE_LIGHT_ICON_PATH = './images/key-icons/transport/transportPauseKey_Light@2x.png';
const TRANSPORT_PAUSE_DARK_ICON_PATH = './images/key-icons/transport/transportPauseKey_Dark@2x.png';
const TRANSPORT_SKIP_FORWARD_LIGHT_ICON_PATH = './images/key-icons/transport/transportSkipForwardKey_Light@2x.png';
const TRANSPORT_SKIP_FORWARD_DARK_ICON_PATH = './images/key-icons/transport/transportSkipForwardKey_Dark@2x.png';
const TRANSPORT_SKIP_BACKWARD_LIGHT_ICON_PATH = './images/key-icons/transport/transportSkipBackwardKey_Light@2x.png';
const TRANSPORT_SKIP_BACKWARD_DARK_ICON_PATH = './images/key-icons/transport/transportSkipBackwardKey_Dark@2x.png';
const TRANSPORT_GO_TO_END_LIGHT_ICON_PATH = './images/key-icons/transport/transportGoToEndKey_Light@2x.png';
const TRANSPORT_GO_TO_END_DARK_ICON_PATH = './images/key-icons/transport/transportGoToEndKey_Dark@2x.png';

// Prop Action Key Icon Paths
const PROP_TRIGGER_LIGHT_ICON_PATH = './images/key-icons/prop/propTriggerKey_Light@2x.png';
const PROP_TRIGGER_DARK_ICON_PATH = './images/key-icons/prop/propTriggerKey_Dark@2x.png';
const PROP_CLEAR_LIGHT_ICON_PATH = './images/key-icons/prop/propClearKey_Light@2x.png';
const PROP_CLEAR_DARK_ICON_PATH = './images/key-icons/prop/propClearKey_Dark@2x.png';

// Look Action Key Icon Paths
const LOOK_LIGHT_ICON_PATH = './images/key-icons/look/lookTriggerKey_Light@2x.png';
const LOOK_DARK_ICON_PATH = './images/key-icons/look/lookTriggerKey_Dark@2x.png';

// Macro Action Key Icon Paths
const MACRO_LIGHT_ICON_PATH = './images/key-icons/macro/macroKey_Light@2x.png';
const MACRO_DARK_ICON_PATH = './images/key-icons/macro/macroKey_Dark@2x.png';

// Video Input Action Key Icon Paths
const VIDEO_INPUT_TRIGGER_LIGHT_ICON_PATH = './images/key-icons/videoInput/videoInputTriggerKey_Light@2x.png';
const VIDEO_INPUT_TRIGGER_DARK_ICON_PATH = './images/key-icons/videoInput/videoInputTriggerKey_Dark@2x.png';

// Icons Dictionary
const KEY_ICONS = {
  'com.renewedvision.propresenter.audio': {
    lightIcon: AUDIO_LIGHT_ICON_PATH,
    darkIcon: AUDIO_DARK_ICON_PATH,
  },
  'com.renewedvision.propresenter.capture': {
    start: {
      lightIcon: CAPTURE_START_LIGHT_ICON_PATH,
      darkIcon: CAPTURE_START_DARK_ICON_PATH,
    },
    stop: {
      lightIcon: CAPTURE_STOP_LIGHT_ICON_PATH,
      darkIcon: CAPTURE_STOP_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.clear': {
    0: {
      lightIcon: CLEAR_GROUP_ZERO_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ZERO_DARK_ICON_PATH,
    },
    1: {
      lightIcon: CLEAR_GROUP_ONE_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ONE_DARK_ICON_PATH,
    },
    2: {
      lightIcon: CLEAR_GROUP_TWO_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_TWO_DARK_ICON_PATH,
    },
    3: {
      lightIcon: CLEAR_GROUP_THREE_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_THREE_DARK_ICON_PATH,
    },
    4: {
      lightIcon: CLEAR_GROUP_FOUR_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_FOUR_DARK_ICON_PATH,
    },
    5: {
      lightIcon: CLEAR_GROUP_FIVE_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_FIVE_DARK_ICON_PATH,
    },
    6: {
      lightIcon: CLEAR_GROUP_SIX_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_SIX_DARK_ICON_PATH,
    },
    7: {
      lightIcon: CLEAR_GROUP_SEVEN_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_SEVEN_DARK_ICON_PATH,
    },
    8: {
      lightIcon: CLEAR_GROUP_EIGHT_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_EIGHT_DARK_ICON_PATH,
    },
    9: {
      lightIcon: CLEAR_GROUP_NINE_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_NINE_DARK_ICON_PATH,
    },
    X: {
      lightIcon: CLEAR_GROUP_ALL_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ALL_DARK_ICON_PATH,
    },
    All: {
      lightIcon: CLEAR_GROUP_ALL_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ALL_DARK_ICON_PATH,
    },
    Megahorn: {
      lightIcon: CLEAR_GROUP_ANNOUNCEMENTS_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ANNOUNCEMENTS_DARK_ICON_PATH,
    },
    Play: {
      lightIcon: CLEAR_GROUP_PLAY_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_PLAY_DARK_ICON_PATH,
    },
    Bulb: {
      lightIcon: CLEAR_GROUP_LIGHT_BULB_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_LIGHT_BULB_DARK_ICON_PATH,
    },
    Sunglasses: {
      lightIcon: CLEAR_GROUP_SUNGLASSES_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_SUNGLASSES_DARK_ICON_PATH,
    },
    Arrow: {
      lightIcon: CLEAR_GROUP_ARROW_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ARROW_DARK_ICON_PATH,
    },
    Target: {
      lightIcon: CLEAR_GROUP_TARGET_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_TARGET_DARK_ICON_PATH,
    },
    Star: {
      lightIcon: CLEAR_GROUP_STAR_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_STAR_DARK_ICON_PATH,
    },
    Sun: {
      lightIcon: CLEAR_GROUP_SUN_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_SUN_DARK_ICON_PATH,
    },
    Bell: {
      lightIcon: CLEAR_GROUP_BELL_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_BELL_DARK_ICON_PATH,
    },
    Paperclip: {
      lightIcon: CLEAR_GROUP_PAPERCLIP_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_PAPERCLIP_DARK_ICON_PATH,
    },
    Flask: {
      lightIcon: CLEAR_GROUP_FLASK_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_FLASK_DARK_ICON_PATH,
    },
    Eyeglasses: {
      lightIcon: CLEAR_GROUP_EYEGLASSES_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_EYEGLASSES_DARK_ICON_PATH,
    },
    Cupcake: {
      lightIcon: CLEAR_GROUP_CUPCAKE_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_CUPCAKE_DARK_ICON_PATH,
    },
    Slide: {
      lightIcon: CLEAR_GROUP_PRESENTATION_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_PRESENTATION_DARK_ICON_PATH,
    },
    Hat: {
      lightIcon: CLEAR_GROUP_HAT_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_HAT_DARK_ICON_PATH,
    },
    Flower: {
      lightIcon: CLEAR_GROUP_FLOWER_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_FLOWER_DARK_ICON_PATH,
    },
    Heart: {
      lightIcon: CLEAR_GROUP_HEART_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_HEART_DARK_ICON_PATH,
    },
    Cloud: {
      lightIcon: CLEAR_GROUP_CLOUD_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_CLOUD_DARK_ICON_PATH,
    },
    Exclamation: {
      lightIcon: CLEAR_GROUP_EXCLAMATION_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_EXCLAMATION_DARK_ICON_PATH,
    },
    Audio: {
      lightIcon: CLEAR_GROUP_MUSIC_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_MUSIC_DARK_ICON_PATH,
    },
    Message: {
      lightIcon: CLEAR_GROUP_MESSAGE_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_MESSAGE_DARK_ICON_PATH,
    },
    Custom: {
      lightIcon: CLEAR_GROUP_ALL_LIGHT_ICON_PATH,
      darkIcon: CLEAR_GROUP_ALL_DARK_ICON_PATH,
    },
    'Audio-Layer': {
      lightIcon: CLEAR_AUDIO_LIGHT_ICON_PATH,
      darkIcon: CLEAR_AUDIO_DARK_ICON_PATH,
    },
    'Message-Layer': {
      lightIcon: CLEAR_MESSAGES_LIGHT_ICON_PATH,
      darkIcon: CLEAR_MESSAGES_DARK_ICON_PATH,
    },
    'Prop-Layer': {
      lightIcon: CLEAR_PROPS_LIGHT_ICON_PATH,
      darkIcon: CLEAR_PROPS_DARK_ICON_PATH,
    },
    'Announcement-Layer': {
      lightIcon: CLEAR_ANNOUNCEMENTS_LIGHT_ICON_PATH,
      darkIcon: CLEAR_ANNOUNCEMENTS_DARK_ICON_PATH,
    },
    'Slide-Layer': {
      lightIcon: CLEAR_PRESENTATION_LIGHT_ICON_PATH,
      darkIcon: CLEAR_PRESENTATION_DARK_ICON_PATH,
    },
    'Media-Layer': {
      lightIcon: CLEAR_MEDIA_LIGHT_ICON_PATH,
      darkIcon: CLEAR_MEDIA_DARK_ICON_PATH,
    },
    'Video-Input-Layer': {
      lightIcon: CLEAR_VIDEO_INPUT_LIGHT_ICON_PATH,
      darkIcon: CLEAR_VIDEO_INPUT_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.findmymouse': {
    lightIcon: FIND_MY_MOUSE_LIGHT_ICON_PATH,
    darkIcon: FIND_MY_MOUSE_DARK_ICON_PATH,
  },
  'com.renewedvision.propresenter.group': {
    trigger: {
      lightIcon: GROUP_LIGHT_ICON_PATH,
      darkIcon: GROUP_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.look': {
    lightIcon: LOOK_LIGHT_ICON_PATH,
    darkIcon: LOOK_DARK_ICON_PATH,
  },
  'com.renewedvision.propresenter.macro': {
    lightIcon: MACRO_LIGHT_ICON_PATH,
    darkIcon: MACRO_DARK_ICON_PATH,
  },
  'com.renewedvision.propresenter.prop': {
    trigger: {
      lightIcon: PROP_TRIGGER_LIGHT_ICON_PATH,
      darkIcon: PROP_TRIGGER_DARK_ICON_PATH,
    },
    clear: {
      lightIcon: PROP_CLEAR_LIGHT_ICON_PATH,
      darkIcon: PROP_CLEAR_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.slide': {
    next: {
      lightIcon: SLIDE_NEXT_LIGHT_ICON_PATH,
      darkIcon: SLIDE_NEXT_DARK_ICON_PATH,
    },
    previous: {
      lightIcon: SLIDE_PREVIOUS_LIGHT_ICON_PATH,
      darkIcon: SLIDE_PREVIOUS_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.stagemessage': {
    show: {
      lightIcon: STAGE_SHOW_LIGHT_ICON_PATH,
      darkIcon: STAGE_SHOW_DARK_ICON_PATH,
    },
    hide: {
      lightIcon: STAGE_HIDE_LIGHT_ICON_PATH,
      darkIcon: STAGE_HIDE_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.timeline': {
    play: {
      lightIcon: PLAY_LIGHT_ICON_PATH,
      darkIcon: PLAY_DARK_ICON_PATH,
    },
    stop: {
      lightIcon: STOP_LIGHT_ICON_PATH,
      darkIcon: STOP_DARK_ICON_PATH,
    },
    goToBeginning: {
      lightIcon: RESET_LIGHT_ICON_PATH,
      darkIcon: RESET_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.timer': {
    start: {
      lightIcon: PLAY_LIGHT_ICON_PATH,
      darkIcon: PLAY_DARK_ICON_PATH,
    },
    stop: {
      lightIcon: STOP_LIGHT_ICON_PATH,
      darkIcon: STOP_DARK_ICON_PATH,
    },
    reset: {
      lightIcon: RESET_LIGHT_ICON_PATH,
      darkIcon: RESET_DARK_ICON_PATH,
    },
    increment: {
      lightIcon: INCREMENT_LIGHT_ICON_PATH,
      darkIcon: INCREMENT_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.transport': {
    play: {
      lightIcon: TRANSPORT_PLAY_LIGHT_ICON_PATH,
      darkIcon: TRANSPORT_PLAY_DARK_ICON_PATH,
    },
    pause: {
      lightIcon: TRANSPORT_PAUSE_LIGHT_ICON_PATH,
      darkIcon: TRANSPORT_PAUSE_DARK_ICON_PATH,
    },
    skipForward: {
      lightIcon: TRANSPORT_SKIP_FORWARD_LIGHT_ICON_PATH,
      darkIcon: TRANSPORT_SKIP_FORWARD_DARK_ICON_PATH,
    },
    skipBackward: {
      lightIcon: TRANSPORT_SKIP_BACKWARD_LIGHT_ICON_PATH,
      darkIcon: TRANSPORT_SKIP_BACKWARD_DARK_ICON_PATH,
    },
    goToEnd: {
      lightIcon: TRANSPORT_GO_TO_END_LIGHT_ICON_PATH,
      darkIcon: TRANSPORT_GO_TO_END_DARK_ICON_PATH,
    },
  },
  'com.renewedvision.propresenter.videoinput': {
    trigger: {
      lightIcon: VIDEO_INPUT_TRIGGER_LIGHT_ICON_PATH,
      darkIcon: VIDEO_INPUT_TRIGGER_DARK_ICON_PATH,
    },
  },
};

if (typeof module !== 'undefined') {
  module.exports = {
    AUDIO_ACTION_ID,
    STAGE_ACTION_ID,
    FIND_MY_MOUSE_ACTION_ID,
    CAPTURE_ACTION_ID,
    CLEAR_ACTION_ID,
    GROUP_ACTION_ID,
    LOOK_ACTION_ID,
    MACRO_ACTION_ID,
    PROP_ACTION_ID,
    SLIDE_ACTION_ID,
    TIMELINE_ACTION_ID,
    TIMER_ACTION_ID,
    TRANSPORT_ACTION_ID,
    VIDEO_INPUT_ACTION_ID,
    KEY_ICONS,
  };
}
