/* eslint-disable import/no-extraneous-dependencies, no-console */
// eslint-disable-next-line no-unused-vars
/* global $SD, describe, it, beforeEach, afterEach */
const assert = require('assert');
const sinon = require('sinon');
const Constants = require('../../js/constants');
const FakeAPIManager = require('../fakes/FakeAPIManager');
const FakeStreamDeck = require('../fakes/FakeStreamDeck');
const FindMyMouseAction = require('../../js/actions/FindMyMouseAction');

function test() {
  // *** Setup ***

  let apiManager;
  let action;

  // eslint-disable-next-line prefer-arrow-callback, func-names
  beforeEach(function (done) {
    apiManager = new FakeAPIManager();
    action = new FindMyMouseAction(apiManager);
    done();
  });

  // *** Tests ***

  it('Should initialize a new Find My Mouse Action instance', () => {
    assert(action != null);
  });

  it('Should fire APIManager findMyMouse when keyUp event fires', () => {
    const json = FakeStreamDeck.generateJSON(Constants.FIND_MY_MOUSE_ACTION_ID);
    const spyOnFindMyMouse = sinon.spy(apiManager, 'findMyMouse');

    action.onKeyUp(json);

    assert(spyOnFindMyMouse.called);
  });
}

module.exports = test;
